## pbP[W̓ǂݍ
library(lavaan)
library(semTools)

## f[^̓ǂݍ
semidata<-read.csv("dat/semidata.csv")
head(semidata)


### 4.1 ###
## cx̌vZ
skew(semidata[,1])

## x̌vZ
kurtosis(semidata[,1])


### 4.2 ###
## uZ~i[f[^ṽf̎wƎs
model1 <- ' f1 =~ x1 + x2 + x3 + x4 
            f2 =~ x5 + x6 +x7
            f2 ~ f1 '
fit1 <- sem(model1, data=semidata)
summary(fit1)

## p[^e[ȕo
parTable(fit1)

## lavaan()pꍇ̃f̎wƎs
model2 <- ' f1 =~ 1*x1 + x2 + x3 + x4 
            f2 =~ 1*x5 + x6 +x7
            f2 ~ f1 
            x1 ~~ x1
            x2 ~~ x2
            x3 ~~ x3
            x4 ~~ x4
            x5 ~~ x5
            x6 ~~ x6
            x7 ~~ x7
            f1 ~~ f1
            f2 ~~ f2 '
fit2 <- lavaan(model2, data=semidata)
summary(fit2)
parTable(fit2)

## 𗘗plavaan()pꍇ̎s
fit3 <- lavaan(model1, data=semidata, 
               auto.var=TRUE, 
               auto.fix.first=TRUE)
summary(fit3)
parTable(fit3)


### 4.4 ###
## f̋Us
fitted(fit1)

## cs
resid(fit1, type="raw")

## ꐔl̋Us
vcov(fit1)


### 4.5 ###
## p[^e[ȕo
inspect(fit1, what="list")

## p[^e[uLISREL̍s`ŏo
inspect(fit1, what="free")


### 4.6 ###
## l̏o
inspect(fit1, what="start")

## ϑϐ̋Us
inspect(fit1, what="sampstat")

## f̑֍s
inspect(fit1, what="cor.all")

## f̋UsiϑϐEݕϐ̗j
inspect(fit1, what="cov.all")

## W̏o
inspect(fit1, what="rsquare")

## W̏óisummary()pāj
summary(fit1, rsquare=TRUE)


### 4.8 ###
## Ԑڌʂ̃f̎s
model.ind <- ' x5 ~ c*x2
               x6 ~ a*x2
               x5 ~ b*x6
               ab := a*b
            total := c + (a*b)'
fit.ind <- sem(model.ind, data=semidata)
summary(fit.ind)

# Ԑڌʂ̎
med <- 'a*b'

# pXW̎w
co1<-coef(fit.ind)[["a"]]
co2<-coef(fit.ind)[["b"]]

# ꐔ̑QߓIUs
AC <- vcov(fit.ind)[c(2,3),c(2,3)]

# MԂ̎Zo
monteCarloMed(expression=med, 
    coef1=co1, coef2=co2, ACM=AC,
    outputValues=FALSE, plot=TRUE)


### 4.9 ###
## CwW̏o
(MI <- modificationIndices(fit1))
# CwW3ȏ̂̂̂ݎoB
subset(MI, mi>3)
# qׂɊւCwŴݎoB
subset(MI, op == "=~")

## h
model.con <- ' f1 =~ con1*x1 + con1*x2 + con1*x3 + con1*x4 
               f2 =~ con2*x5 + con2*x6 + con2*x7
               f2 ~ f1 '
fit.con <- sem(model.con, std.lv=TRUE, data=semidata)
summary(fit.con, fit.measure=TRUE)

wald(fit.con,"con2-con1")


### K ###
## H1
lower_A <- '
1.850 
0.787 1.428 
0.363 0.488 1.423 
1.181 0.832 1.495 10.491 
1.220 1.170 0.912  1.453 15.210 
0.980 0.965 0.759  1.427  6.734 7.393'
A.cov <- getCov(lower_A, 
         names=paste("x",1:6,sep=""))
A.cov


model3 <- 'f1 =~ x1 + x2
           f2 =~ x3 + x4
           f3 =~ x5 + x6
           f3 ~ f1 + f2'


fit.A<-sem(model=model3, sample.cov=A.cov,
           sample.nobs=200,estimator="ML")
summary(fit.A,fit.measure=T)
standardizedSolution(fit.A)

## H2iȗj
model3.lav1 <- 'f1 =~ x1 + x2
                f2 =~ x3 + x4
                f3 =~ x5 + x6
                f3 ~ f1 + f2'
fit.A.lav1 <- lavaan(model=model3.lav1, sample.cov=A.cov,
                     sample.nobs=200, estimator="ML",
                     auto.var=TRUE, auto.fix.first=TRUE, auto.cov.lv.x=TRUE)
summary(fit.A.lav1,fit.measure=T)

## H2iȗȂj
model3.lav2 <- 'f1 =~ 1*x1 + x2
                f2 =~ 1*x3 + x4
                f3 =~ 1*x5 + x6
                f3 ~    f1 + f2
                x1 ~~ x1
                x2 ~~ x2
                x3 ~~ x3
                x4 ~~ x4
                x5 ~~ x5
                x6 ~~ x6
                f1 ~~ f1
                f2 ~~ f2
                f3 ~~ f3
                f1 ~~ f2'
fit.A.lav2 <- lavaan(model=model3.lav2, sample.cov=A.cov,
                     sample.nobs=200, estimator="ML")
summary(fit.A.lav2,fit.measure=T)

## H3
# xt̃XNvg
model3.con <- 'f1 =~ x1 + x2
               f2 =~ x3 + x4
               f3 =~ x5 + x6
               f3 ~ a*f1 + b*f2
@@@@@@@@@@@@@@@dif:=a-b'
fit.A.con<-sem(model=model3.con, sample.cov=A.cov,
               sample.nobs=200,estimator="ML")
summary(fit.A.con,fit.measure=T)
standardizedSolution(fit.A.con)
# h̎s
wald(fit.A.con,"a-b")