### 7.1
modelReg <- ' len ~ 1 + supp '

library(lavaan)
dataTooth <- read.csv('dat/tooth.csv')
fitReg <- sem(modelReg, dataTooth)
summary(fitReg, standardized=TRUE)

### \7.1
### Wc

lower <- '
  0.9983
  0.4901 1.0031
  0.4203 0.4235 1.0016
  0.4187 0.4180 0.3585 0.9960
  0.1496 0.1492 0.1286 0.1264 1.0008
  0.1461 0.1465 0.1275 0.1242 0.4929 1.0033
  0.1234 0.1238 0.1057 0.1060 0.4195 0.4217 1.0007
  0.1246 0.1230 0.1071 0.1050 0.4196 0.4226 0.3603 1.0062
'
popCov <- getCov(lower, names=paste("x",1:8,sep=""))

modelFA <- '
f1 =~ x1 + x2 + x3 + x4
f2 =~ x5 + x6 + x7 + x8
'
fitFA_Pop <- cfa(modelFA, sample.cov=popCov, sample.nobs=300000, std.lv=TRUE)
summary(fitFA_Pop, fit.measures=TRUE, standardized=TRUE)

### ݓIAϐ̃f[^
dataCont <- read.csv('dat/latentContinuous.csv')

### ݓIAϐ臒l2lɃJeS[f[^
dataCat2 <- read.csv('dat/cat2.csv')

### ʏiJeS[𖳎Ēʏ̈q́j
fitCat2Normal <- cfa(modelFA, dataCat2, std.lv=TRUE)
summary(fitCat2Normal, standardized=TRUE)

### AiAf[^ɒʏ̈q́j
fitCont <- cfa(modelFA, dataCont, std.lv=TRUE)
summary(fitCont, standardized=TRUE)

### iJeSJϐɃJeSJq́j
fitCat2 <- cfa(modelFA, dataCat2,
   std.lv=TRUE, ordered=paste("x", 1:8, sep=""))
summary(fitCat2, standardized=TRUE)


### 7.2
dataCat2 <- read.csv('dat/cat2.csv') # {ł̃f[^ǂݍ݉ӏ
modelFA <- '                         # {ł̃fwӏ
   f1 =~ x1 + x2 + x3 + x4
   f2 =~ x5 + x6 + x7 + x8
'
fitCat2 <- cfa(modelFA, dataCat2, std.lv=TRUE, 
   ordered=paste("x", 1:8, sep=""))
summary(fitCat2)


### \7.3
### قȂ10̃f[^ɓ͂̕s邪C
### ͂̃XNvĝ͕\7.1ƓȂ̂ŏȗ

### }7.2
dataCat3 <- read.csv('dat/cat3.csv')
fitCat3 <- cfa(modelFA, dataCat3, std.lv=TRUE, 
   ordered=paste("x", 1:8, sep=""))

library(semPlot)
semPaths(fitCat3, style="lisrel", whatLabels="std",
  layout="tree", sizeLat=6, sizeLat2=4, sizeInt=3,
  thresholdSize=1.0, edge.label.cex=0.7)

### \7.4
### \7.3Ɠl̗Rɂȗ

### \7.5
### \7.3Ɠl̗Rɂȗ


### 7.5
library(semTools)
dataNN <- read.csv('dat/nonNormal.csv')

### eϐ̘cxƐx
lapply(dataNN, skew)
lapply(dataNN, kurtosis)

### ϗʘcxƑϗʐx
mardiaSkew(dataNN)
mardiaKurtosis(dataNN)

### \7.7
fitNN <- cfa(modelFA, dataNN, std.lv=TRUE,
   estimator="MLR")
summary(fitNN, fit.measures=TRUE, standardized=TRUE)

### 񐳋Kz̕Wc
NNlower <- '
1.4951
0.4923 1.4907
0.4232 0.4177 1.3640
0.4177 0.4154 0.3603 1.3563
0.1459 0.1440 0.1219 0.1229 1.4833
0.1510 0.1498 0.1297 0.1248 0.4853 1.4941
0.1207 0.1241 0.1024 0.0992 0.4177 0.4220 1.3647
0.1279 0.1247 0.1076 0.1052 0.4180 0.4220 0.3584 1.3555
'

NNpopCov <- getCov(NNlower, names=paste("x",1:8,sep=""))
fitFA_NNpop <- cfa(modelFA, sample.cov=NNpopCov, sample.nobs=300000, std.lv=TRUE)
summary(fitFA_NNpop, fit.measures=TRUE, standardized=TRUE)



